/*******************************************
 * Contains exception classes for MergeTag.
 *
 * Publically imports mde.exception.
 ******************************************/
module mde.mergetag.exception;

public import mde.exception;

/// Base MergeTag exception class.
class MTException : mdeException {
    this (char[] msg) {
        super("MergeTag: " ~ msg);
    }
    this () {}
}

/** Thrown on file IO errors. */
class MTFileIOException : MTException {
    this () {}
}

/** Thrown onunknown format errors; when reading or writing and the filetype cannot be guessed. */
class MTFileFormatException : MTException {
    this () {}
}

/** Thrown when a string ID is parsed but cannot be found in the lookup table, hence cannot be used
 * as an ID. It should always be caught and handled gracefully (by ignoring the tag or section
 * involved).
 */
class MTStringIDException : MTException {
    this () {}
}

/** Thrown by the parse module on any error.
 */
class MTParseException : MTException {
    this () {}
}

/** Thrown by classes implementing DataSection when addTag is called with an unrecognised type string.
 */
class MTUnknownTypeException : MTException {
    this () {}
}
